<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="120px">
      <el-form-item label="工作单元名称" prop="workunitName">
        <el-input
          v-model="queryParams.workunitName"
          placeholder="请输入工作单元名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="工作单元编码" prop="workunitCode">
        <el-input
          v-model="queryParams.workunitCode"
          placeholder="请输入工作单元编码"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          size="mini"
          @click="handleUpdate"
        >批量下机</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="recordList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="物料编码" width="130" align="center" prop="sapItemCode" />
      <el-table-column label="物料名称" width="100" align="center" prop="itemName" />
      <el-table-column label="工作单元编码" min-width="100" align="center" prop="workunitCode" />
      <el-table-column label="工作单元名称" min-width="120" align="center" prop="workunitName" />
      <el-table-column label="任务编码" width="120" align="center" prop="taskCode" />
      <el-table-column label="任务名称" show-overflow-tooltip min-width="220" align="center" prop="taskName" />
      <el-table-column label="上机状态" width="100" align="center" prop="typeName" />
      <el-table-column label="数量" width="80" align="center" prop="allQuantity" />
      <el-table-column label="使用寿命" width="80" align="center" prop="nextMaintenPeriod" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listWorkTmToolRequestList } from "@/api/mes/md/workunit";
import { updateTmToolMachines } from "@/api/mes/tm/tmToolMachines";

export default {
  name: "Record",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 刀模版上下机记录表格数据
      recordList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        workunitCode: null,
        workunitName: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      tableSelectData: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询上机明细列表 */
    getList() {
      this.loading = true;
      const params = Object.assign({}, this.queryParams)
      delete params.type
      listWorkTmToolRequestList(params).then(response => {
        this.recordList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        workunitCode: null,
        workunitName: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.toolMachinesRecordId)
      this.tableSelectData = selection
      console.log(this.tableSelectData, 'this.tableSelectData')
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 修改下机按钮操作 */
    handleUpdate(row) {
      const params = this.tableSelectData.map((v) => {
        return {
          toolMachinesId: v.toolMachinesId,
          type: '2'
        };
      });
      updateTmToolMachines(params).then(response => {
        if (response.code == 200) {
          this.getList();
        }
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.toolMachinesRecordId != null) {
            updateRecord(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRecord(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const toolMachinesRecordIds = row.toolMachinesRecordId || this.ids;
      this.$modal.confirm('是否确认删除刀模版上下机记录编号为"' + toolMachinesRecordIds + '"的数据项？').then(function() {
        return delRecord(toolMachinesRecordIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('md/record/export', {
        ...this.queryParams
      }, `record_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
